﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ConsoleApplication4;
using Moq;
using Xunit;

namespace ClassLibrary1
{
  public class FriendPrinterTests
  {
    [Fact]
    public void ShouldPrintFormattedFriends()
    {
      var sb = new StringBuilder();
      var sw = new StringWriter(sb);

      var printer = new FriendPrinter(sw);
      var friends = new List<Friend>
        {
          new Friend {FirstName = "Julia", LastName = "Huber"}
        };
      var friendFormatterMock = new Mock<IFriendFormatter>();
      friendFormatterMock.Setup(f => f.Format(It.IsAny<Friend>()))
        .Returns("FormattedFriend");
      IFriendFormatter friendFormatter = friendFormatterMock.Object;

      printer.PrintFriends(friends, friendFormatter);

      var result = sb.ToString();

      Assert.Equal("FormattedFriend\r\n", result);
    }

  
  }
}
