using System.Collections.Generic;
using System.IO;

namespace ConsoleApplication4
{
  public class FriendDataProvider:IFriendDDataProvider
  {

    public List<Friend> LoadFriends()
    {
      var fileName = "friends.csv";
      var friends = new List<Friend>();
      using (var fileStream = new FileStream(fileName, FileMode.Open))
      {
        using (var streamReader = new StreamReader(fileStream))
        {
          while (streamReader.Peek() != -1)
          {
            var line = streamReader.ReadLine();
            if (line == null)
            {
              break;
            }
            var lineItems = line.Split(',');
            var friend = new Friend
            {
              FirstName = lineItems[0],
              LastName = lineItems[1]
            };
            friends.Add(friend);
          }
        }
      }
      return friends;
    }
  }

  public interface IFriendDDataProvider
  {
    List<Friend> LoadFriends();
  }

  public interface IFriendSaveDataProvider:IFriendDDataProvider
  {
    void SaveFriends(IEnumerable<Friend> friends);
  }

  public class FriendDataBaseDataProvider : IFriendSaveDataProvider
  {
    public List<Friend> LoadFriends()
    {
      return null;
    }

    public void SaveFriends(IEnumerable<Friend> friends)
    {
      
    }
  }
}