using System;
using System.Collections.Generic;
using System.IO;

namespace ConsoleApplication4
{
  public class FriendPrinter
  {
    private readonly TextWriter _textWriter;

    public FriendPrinter(TextWriter textWriter)
    {
      _textWriter = textWriter;
    }

    public void PrintFriends(List<Friend> friends,
      IFriendFormatter formatter)
    {
      foreach (var friend in friends)
      {
        _textWriter.WriteLine(formatter.Format(friend));
      }
    }
  }

  public interface IFriendFormatter
  {
    string Format(Friend friend);
  }

  public class FriendFormatterFirstNameFirst: IFriendFormatter
  {
    public string Format(Friend friend)
    {
      return $"{friend.FirstName} {friend.LastName}";
    }
  }

  public class FriendFormatterLastNameFirst:IFriendFormatter
  {
    public string Format(Friend friend)
    {
      return $"{friend.LastName} {friend.FirstName}";
    }
  }

  public class FriendFormatterFirstNameFirstDashes : IFriendFormatter
  {
    public string Format(Friend friend)
    {
      return $"{friend.LastName} ------ {friend.FirstName}";
    }
  }
}